@ gba library maths routines.
@ written by: Pete (dooby@bits.bris.ac.uk)
@ Some of these were taken from Acorn/ARM docs, some from the GBA BIOS.
@
@ NOTE: I grabbed this routine from a library of freeware routines
@       I found on the internet
@       - Doug Lanford (opus@opusgames.com)

  .GLOBAL s32_div
  .GLOBAL debug_print

	.TEXT


@ signed long int s32_div(signed long int numerator, signed long int denominator)@
@ Equivalent to '(int)(n / d)' in C
@ a1 = top
@ a2 = bottom
@ a3 = temp
@ a4 = div
s32_div:
	mov	ip, #1		@ Set sign +ve.
	cmp	a1, #0		@ Is top -ve?
	rsblt	ip, ip, #0	@ Flip sign if top -ve.
	rsblt	a1, a1, #0	@ Flip top if -ve.
	movs	a3, a2		@ Put divisor in temp.
	rsbmi	ip, ip, #0	@ Flip sign if divisor -ve.
	rsbmi	a2, a2, #0	@ Flip bottom if -ve.
	rsbmi	a3, a3, #0	@ Flip bottom if -ve.
	cmp	a3, a1, lsr #1	@ Is it > top/2?
gba_div_x2:
	movls	a3, a3, lsl #1	@ No, so double it.
	cmp	a3, a1, lsr #1	@ Is it > top/2?
	bls	gba_div_x2	@ No - loop.
	mov	a4, #0		@ Initialise quotient.
gba_div_sub:
	cmp	a1, a3		@ Can we subtract temp?
	subcs	a1, a1, a3	@ Yes - so do.
	adc	a4, a4, a4	@ Double div and add new bit.
	mov	a3, a3, lsr #1	@ Halve temp.
	cmp	a3, a2		@ Have we gone past the divisor?
	bhs	gba_div_sub	@ No - loop.
	mov	a1, a4		@ Return remainder in a1.
	cmp	ip, #0		@ Was sign -ve?
	rsblt	a1, a1, #0	@ Negate result if so.
	mov	pc, lr		@ And exit.

.pool


