/******************************************************************************
 * powerup object headers
 *
 * written by Doug Lanford, opus@opusgames.com
 * for more info, go to www.opusgames.com
 *
 * This file is provided as freeware
 *****************************************************************************/

#ifndef _POWERUP_H
#define	_POWERUP_H

#include "types.h"
#include "math.h"
#include "object.h"


typedef struct PowerupStruct
{
	OBJECT_HEADER

	s24f8_vect2D	pos;		// world position of the bullet
	s24f8_vect2D	speed;		// speed vector of the bullet

	u16				health;		// how much helath the powerup is worth

} PowerupStruct;


/********************************************************************
 * launch a powerup
 *
 * IN:		world position of the powerup
 * 			amount of health the powerup gives if picked up
 *
 * RETURNS:	ptr to the powerup object
 *******************************************************************/
extern PowerupStruct *Powerup_New (s24f8_vect2D *pPos, u16 health);


/**********************************************************************
 * update a powerup object
 *********************************************************************/
extern u32 Powerup_Update (ObjectStruct *pObj);


#endif


