/********************************************************************
 * text and number displaying headers
 *
 * written by Doug Lanford, opus@opusgames.com
 * for more info, go to www.opusgames.com
 *
 * This file is provided as freeware
 ********************************************************************/

#ifndef _TEXT_H
#define	_TEXT_H

#include "types.h"


/********************************************************************************
 * display a number at a screen position on the screen
 *
 * IN:		screenX, screenY = screen position (0,0 = top-left corner of screen)
 * 			num = value to display
 *******************************************************************************/
extern void Text_DrawNumber(u16 screenX, u16 screenY, u16 num);


/********************************************************************************
 * display text at a screen position on the screen
 *
 * IN:		screenX, screenY = screen position (0,0 = top-left corner of screen)
 * 			pText = text to print
 *******************************************************************************/
extern void Text_DrawString(u16 screenX, u16 screenY, u8 *pText);


#endif

